import 'package:flutter/widgets.dart';

mixin InitializeMixin<T extends StatefulWidget> on State<T> {
  
    bool isInitialized;

    @override
    void initState() 
    {
        super.initState();
        
        if(isInitialized != true)
        {
            isInitialized = true;
            WidgetsBinding.instance.addPostFrameCallback((_) => initialized(context));
        }
    }

    void initialized(BuildContext context);
}