import 'package:flutter/foundation.dart';

enum _CruiserLogLevel { info, warning }

String _logLevelToString(_CruiserLogLevel level) 
{
    return level.toString().split(".")[1].toUpperCase();
}

class CruiserLogger 
{
    static CruiserLogger _instance;

    final bool isLoggerEnabled;

    CruiserLogger._internal({@required this.isLoggerEnabled,});

    static void init({bool isLoggerEnabled}) 
    {
        _instance = CruiserLogger._internal(isLoggerEnabled: isLoggerEnabled);
    }

    static CruiserLogger get instance => _instance;

    void info(String message) 
    {
        _log(level: _CruiserLogLevel.info, message: message);
    }

    void warning(String message) 
    {
        _log(level: _CruiserLogLevel.warning, message: message);
    }

    void _log({String message, _CruiserLogLevel level}) 
    {
        if (this.isLoggerEnabled) 
        {
            print("[Cruiser] ${_logLevelToString(level)} : $message");
        }
    }
}
