import 'package:cruiser/src/models/cruiser_args.dart';
import 'package:flutter/widgets.dart';

typedef CruiserRouteBuilder = Widget Function
(
    BuildContext context,
    CruiserArgs args,
);

class CruiserRoute 
{
    final String name;
    final CruiserRouteBuilder builder;
    final CruiserArgs defaultArgs;

    const CruiserRoute
    ({
        @required this.name,
        @required this.builder,
        this.defaultArgs,
    })  
    : assert(name != null), assert(builder != null);
}
