
import 'package:cruiser/src/models/cruiser_transition.dart';
import 'package:flutter/widgets.dart';

class StackTransition extends CruiserTransition
{
    final Curve curve;

    StackTransition({
        this.curve = Curves.easeOutSine,
    });

    @override
    Widget build(BuildContext context, Animation<double> primaryAnimation, Animation<double> secondaryAnimation, Widget child) 
    {
        final double width = MediaQuery.of(context).size.width;

        var animation = CurvedAnimation(parent: primaryAnimation, curve: curve);

        return Transform(
            transform: Matrix4.identity()..translate(width * (1.0 - animation.value)),
            child: child,
        );
    }
}